import jp.jig.jiglet.*;

public class RSS extends Jiglet {
	String[][] channelList;
	String[][] itemList;
	boolean[] checked;
	
	int state = 0;		//1:`lꗗ 2:Lꗗ 3:`lI 4:Lꗗj[
	int channelCursor;
	int channelOffset;
	int dataCursor;
	int dataOffset;
	
	int fontH;
	int altH;
	int titleH;
	
	String today;
	String title;
	Image checkImage;
	
	int lastCursor = -1;
	
	int subMenuCursor;
	
	String[] SUB_MENU_LIST = new String[] {
		"ǉ",
		"ꌏ폜",
		"Sǉ",
		"S폜",
		"`lꗗ",
	};
	
	void setState(int n) {
		state = n;
		if (state == 1) {
			setSoftLabel("I");
			title = "`lꗗ";
		} else if (state == 2) {
			setSoftLabel("@\");
		} else if (state == 3) {
			setSoftLabel("");
			title = "`lI";
		} else if (state == 4) {
			setSoftLabel("߂");
		}
		lastCursor = -1;
	}
	
	public void main() {
		lastCursor = -1;
		
		if (state == 0 || state == 1) {
			setTitle("RSS");
			getSelectedChannels();
			
			if (state == 0) {
				checkImage = getImage("check.gif");
				
				channelCursor = 0;
				channelOffset = 0;
				dataCursor = 0;
				dataOffset = 0;
				state = 1;
				
				fontH = getFontHeight();
				titleH = fontH + 6;
				altH = fontH * 3 + 12;
				
				setTime(currentTime());
				
				int month = getTime(CALENDAR_MONTH);
				int date = getTime(CALENDAR_DATE);
				
				today = "";
				if (month < 10) {
					today = "0";
				}
				today += month + ":";
				if (date < 10) {
					today += "0";
				}
				today += date;
				
				setState(1);
			}
		} else if (state == 2) {
			setState(2);
		} else if (state == 3) {
			setState(3);
		}
		
		int row = (DH - altH - titleH) / (fontH + 2);
		clearKey();
		
		for (;;) {
			int key = getKey();
			if (state == 1 || state == 3) {
		//`lI
				if (channelOffset > channelCursor) {
					channelOffset = channelCursor;
					lastCursor = -1;
				}
				if (channelOffset <= channelCursor - row) {
					channelOffset = channelCursor - row + 1;
					lastCursor = -1;
				}
				if (channelOffset < 0) {
					channelOffset = 0;
					lastCursor = -1;
				}
				repaint();
				while (key < 0 && !repaintFlag) {
					sleep(20);
					key = getKey();
				}
				
				int type = (key & 0xF0000);
				key = key & 0xFFFF;
				
				if (type == EVENT_KEY) {
					int len = channelList.length + 2;
					if (state == 3) {
						len = channelList.length;
					}
					if (key == KEY_UP) {
						channelCursor = (channelCursor + len - 1) % len;
					} else if (key == KEY_DOWN) {
						channelCursor = (channelCursor + 1) % len;
					}
					if (state == 1) {
						if (key == KEY_SELECT) {
							if (channelCursor == channelList.length + 1) {
								//RSSXV
								updateRSS();
								getSelectedChannels();
								lastCursor = -1;
							} else if (channelCursor == channelList.length) {
								//`lI
								channelList = getRSSChannels();
								if (channelList.length == 0) {
									if (showDialog("`l񂪂܂BRSSXV܂H", 0) == 0) {
										updateRSS();
									}
									getSelectedChannels();
									lastCursor = -1;
								} else {
									state = 3;
									channelCursor = 0;
									channelOffset = 0;
									
									checked = new boolean[channelList.length];
									for (int i = 0; i < checked.length; i++) {
										checked[i] = (channelList[i][RSS_CHANNEL_SELECTED].charAt(0) == '1');
									}
									setState(3);
								}
							} else {
								//`l̋L\
								itemList = getRSSItems(channelList[channelCursor][RSS_CHANNEL_ID]);
								if (itemList.length == 0) {
									showDialog("̃`lɋLf[^܂", -1);
									lastCursor = -1;
								} else {
									title = channelList[channelCursor][RSS_CHANNEL_TITLE];
									
									dataCursor = 0;
									dataOffset = 0;
									
									setState(2);
								}
							}
						}
						if (key == KEY_SOFT) {
							terminate();
						}
					} else {
						if (key == KEY_SELECT) {
							checked[channelCursor] = !checked[channelCursor];
						}
						if (key == KEY_SOFT) {
							for (int i = 0; i < checked.length; i++) {
								setChannelSelected(channelList[i][RSS_CHANNEL_ID], checked[i]);
							}
							flushRSS();
							
							channelCursor = 0;
							channelOffset = 0;
							
							if (showDialog("RSSXV܂H", 0) == 0) {
								updateRSS();
							}
							setState(1);
							getSelectedChannels();
						}
					}
				}
			} else if (state == 2) {
		//LI
				int len = itemList.length;
				if (len > 0) {
					if (dataOffset > dataCursor) {
						dataOffset = dataCursor;
						lastCursor = -1;
					}
					if (dataOffset <= dataCursor - row) {
						dataOffset = dataCursor - row + 1;
						lastCursor = -1;
					}
					if (dataOffset < 0) {
						dataOffset = 0;
						lastCursor = -1;
					}
				}
				repaint();
				while (key < 0 && !repaintFlag) {
					sleep(20);
					key = getKey();
				}

				int type = (key & 0xF0000);
				key = key & 0xFFFF;
				
				if (type == EVENT_KEY) {
					if (len > 0) {
						if (key == KEY_UP) {
							dataCursor = (dataCursor + len - 1) % len;
						} else if (key == KEY_DOWN) {
							dataCursor = (dataCursor + 1) % len;
						}
						if (key == KEY_SELECT) {
							launch(itemList[dataCursor][RSS_ITEM_URL], ENCODE_SJIS, 0);
						}
					}
					if (key == KEY_IAPP || key == KEY_0) {
						setState(1);
					}
					
					if (key == KEY_RIGHT || key == KEY_LEFT) {
						//EO`l
						int def = 1;
						if (key == KEY_LEFT) {
							def = -1;
						}
						int cl = channelList.length;
						int dc = (channelCursor + def + cl) % cl;
						while (dc != channelCursor) {
							int num = parseInt(channelList[dc][RSS_CHANNEL_ITEM_NUM]);
							if (num > 0) {
								channelCursor = dc;
								
								title = channelList[channelCursor][RSS_CHANNEL_TITLE];
								setTitle(title);
								itemList = getRSSItems(channelList[channelCursor][RSS_CHANNEL_ID]);
								dataCursor = 0;
								dataOffset = 0;
								state = 2;
								break;
							}
							dc = (dc + def + cl) % cl;
						}
						dataCursor = 0;
						dataOffset = 0;
						lastCursor = -1;
					}
					if (key == KEY_SOFT) {
						//@\
						setState(4);
						subMenuCursor = 0;
					}
				}
			} else if (state == 4) {
			//LIpj[
				repaint();
				while (key < 0) {
					sleep(20);
					key = getKey();
				}
				
				int type = (key & 0xF0000);
				key = key & 0xFFFF;
				
				if (type == EVENT_KEY) {
					if (key == KEY_IAPP || key == KEY_SOFT) {
						setState(2);
					}
					
					if (key == KEY_UP) {
						subMenuCursor = (subMenuCursor - 1 + SUB_MENU_LIST.length) % SUB_MENU_LIST.length;
					}
					if (key == KEY_DOWN) {
						subMenuCursor = (subMenuCursor + 1) % SUB_MENU_LIST.length;
					}
					if (key == KEY_SELECT) {
						if (subMenuCursor == 0) {
							//ꌏǉ
							setRSSItemFlag(itemList[dataCursor][RSS_ITEM_ID], false);
							itemList = getRSSItems(channelList[channelCursor][RSS_CHANNEL_ID]);
							flushRSS();
							setState(2);
						} else if (subMenuCursor == 1) {
							//ꌏ폜
							deleteRSSItem(itemList[dataCursor][RSS_ITEM_ID]);
							itemList = getRSSItems(channelList[channelCursor][RSS_CHANNEL_ID]);
							flushRSS();
							dataCursor = 0;
							dataOffset = 0;
							setState(2);
						} else if (subMenuCursor == 2) {
							//Sǉ
							for (int i = 0; i < itemList.length; i++) {
								setRSSItemFlag(itemList[i][RSS_ITEM_ID], false);
							}
							itemList = getRSSItems(channelList[channelCursor][RSS_CHANNEL_ID]);
							flushRSS();
							setState(2);
						} else if (subMenuCursor == 3) {
							//S폜
							for (int i = 0; i < itemList.length; i++) {
								deleteRSSItem(itemList[i][RSS_ITEM_ID]);
							}
							flushRSS();
							setState(1);
						} else if (subMenuCursor == 4) {
							setState(1);
						}
					}
				}
			}
		}
	}
	void getSelectedChannels() {
		String[][] ret = getRSSChannels();
		int num = 0;
		for (int i = 0; i < ret.length; i++) {
			if (ret[i][RSS_CHANNEL_SELECTED].charAt(0) == '1') {
				num++;
			}
		}
		channelList = new String[num][RSS_CHANNEL_LENGTH];
		num = 0;
		for (int i = 0; i < ret.length; i++) {
			if (ret[i][RSS_CHANNEL_SELECTED].charAt(0) == '1') {
				channelList[num] = ret[i];
				num++;
			}
		}
		
		String[] menu = new String[num + 1];
		menu[0] = "`lꗗ";
		for (int i = 0; i < num; i++) {
			menu[i + 1] = channelList[i][RSS_CHANNEL_TITLE];
		}
		//setMenu(menu);
	}
	
	boolean repaintFlag = false;
	public void processMenuEvent(int index) {
		if (index == 0) {
			setState(1);
		} else {
			getSelectedChannels();
			index--;
			if (index < channelList.length) {
				channelCursor = index;
				title = channelList[channelCursor][RSS_CHANNEL_TITLE];
				setTitle(title);
				itemList = getRSSItems(channelList[channelCursor][RSS_CHANNEL_ID]);
				dataCursor = 0;
				dataOffset = 0;
				setState(2);
			} else {
				setState(1);
				channelCursor = 0;
				channelOffset = 0;
			}
		}
		repaintFlag = true;
		lastCursor = -1;
	}
	
	//`
	public void paint(boolean allDrawFlag) {
		if (state == 0) {
			return;
		}
		
		if (allDrawFlag) {
			lastCursor = -1;
		}
		
		setFont(0);
		String altStr = null;
		int btmY = DH - altH;
		
		if (lastCursor < 0 && state <= 3) {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
			fillRect(0, 0, DW, DH);
			
			draw3DButton(0, 0, DW, titleH);
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
			drawString(title, 3, fontH + 3);
			
			drawRect(0, titleH, DW, btmY - titleH);
		}
		
		int barPos = -1;
		int barLen = -1;
		
		if (state == 1 || state == 3) {
			//`lꗗ`
			String[][] ch = channelList;
			
			int y = titleH + 3;
			int len = ch.length + 2;
			if (state == 3) {
				len = ch.length;
			}
			
			barPos = channelOffset;
			barLen = len;
			
			for (int i = channelOffset; i < len; i++) {
				if (lastCursor < 0 || i == channelCursor || i == lastCursor) {
					if (lastCursor >= 0) {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
						fillRect(2, y, DW - 4, fontH + 1);
					}
					String str = "RSSXV";
					if (i == ch.length) {
						str = "`lI";
					} else if (i < ch.length) {
						str = ch[i][RSS_CHANNEL_TITLE];
					}
					
					int idx = 0;
					int sx = 3;
					if (state == 1) {
						if (i == channelCursor) {
							setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
							fillRect(2, y, DW - 4, fontH + 1);
							setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
						} else {
							setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
						}
						idx = getLineBreak(str, 0, str.length(), DW - 6);
					} else {
						draw3DRect(4, y + 1, fontH - 2, fontH - 2);
						if (i == channelCursor) {
							setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
							fillRect(4, y + 1, fontH - 2, fontH - 2);
							setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
						} else {
							setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
						}
						if (checked[i]) {
							int x1 = 6;
							int x2 = 4 + fontH / 2 - 2;
							int x3 = 4 + fontH - 3;
							int y1 = y + fontH / 2;
							int y2 = y + fontH - 3;
							int y3 = y + 4;
							drawLine(x1, y1, x2, y2);
							drawLine(x3, y3, x2, y2);
						}
						idx = getLineBreak(str, 0, str.length(), DW - 6 - fontH);
						sx += fontH;
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
					}
					
					drawString(str.substring(0, idx), sx, y + fontH);
				}
				y += fontH + 2;
				if (y + fontH >= btmY) {
					break;
				}
			}
			if (state == 1) {
				if (channelCursor == ch.length + 1) {
					altStr = "RSSŐV̏̍XV܂";
				} else if (channelCursor == channelList.length) {
					altStr = "f[^擾RSSI܂";
				} else {
					String[] sel = channelList[channelCursor];
					altStr = sel[RSS_CHANNEL_TITLE] + "\nV" + sel[RSS_CHANNEL_NEW_ITEM_NUM] + "/L" + sel[RSS_CHANNEL_ITEM_NUM] + "";
				}
			}
			lastCursor = channelCursor;
		} else if (state == 2) {
			int y = titleH + 3;
			
			barPos = dataOffset;
			barLen = itemList.length;
			
			for (int i = dataOffset; i < itemList.length; i++) {
				if (lastCursor < 0 || i == dataCursor || i == lastCursor) {
					if (lastCursor >= 0) {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
						fillRect(2, y, DW - 4, fontH + 1);
					}
					String str = itemList[i][RSS_ITEM_TITLE];
					if (itemList[i][RSS_ITEM_FLAG].charAt(0) > '0') {
						str = "" + str;
					} else {
						str = "@" + str;
					}
					int idx = getLineBreak(str, 0, str.length(), DW - 6);
					if (i == dataCursor) {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
						fillRect(2, y, DW - 4, fontH + 1);
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
					} else {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
					}
					drawString(str.substring(0, idx), 3, y + fontH);
				}
				y += fontH + 2;
				if (y + fontH >= btmY) {
					break;
				}
			}
			lastCursor = dataCursor;
			if (dataCursor < itemList.length) {
				String[] data = itemList[dataCursor];
				StringBuffer sb = new StringBuffer();
				
				if (data[RSS_ITEM_DATE].equals(today)) {
					sb.append(data[RSS_ITEM_TIME]);
				} else {
					sb.append(data[RSS_ITEM_DATE]);
				}
				sb.append(' ');
				sb.append(data[RSS_ITEM_TITLE]);
				altStr = sb.toString();
				sb = null;
			}
		}
		if (state == 4) {
			//Tuj[`
			int mw = fontH * 7 + 6;
			int mh = (fontH + 2) * SUB_MENU_LIST.length + 6;
			int mx = (DW - mw) / 2;
			int my = (DH - mh) / 2;
			draw3DButton(mx, my, mw, mh);
			
			mx += 3;
			my += 3;
			mw -= 6;
			for (int i = 0; i < SUB_MENU_LIST.length; i++) {
				if (i == subMenuCursor) {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
					fillRect(mx - 1, my, mw + 2, fontH + 1);
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				}
				drawString(SUB_MENU_LIST[i], mx, my + fontH);
				my += fontH + 2;
			}
		} else {
			//ʉEBhE\
			//XN[o[`
			int barH = (btmY - titleH - 1);
			int row = (barH - 3) / (fontH + 2);
			if (row < barLen) {
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
				fillRect(DW - 3, titleH + 1, 3, barH);
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
				barPos = barPos * barH / barLen + titleH + 1;
				barLen = row * barH / barLen;
				fillRect(DW - 3, barPos, 3, barLen);
			}
			
			setColor(getSystemColor(SYSTEM_COLOR_DESCRIPTION_BG));
			fillRect(0, btmY, DW, DH - btmY);
			setColor(getSystemColor(SYSTEM_COLOR_DESCRIPTION_FRAME));
			drawRect(0, btmY, DW - 1, DH - btmY - 1);
			
			if (altStr != null) {
				setColor(getSystemColor(SYSTEM_COLOR_DESCRIPTION_FONT));
				int idx = 0;
				int len = altStr.length();
				int y = btmY + 3 + fontH;
				while (idx < len) {
					int idx2 = getLineBreak(altStr, idx, len - idx, DW - 6);
					int idx3 = altStr.indexOf('\n', idx);
					if (idx3 >= 0 && idx3 < idx2) {
						idx2 = idx3 + 1;
					}
					drawString(altStr.substring(idx, idx2), 3, y);
					idx = idx2;
					y += fontH + 2;
					if (y >= DH) {
						break;
					}
				}
			}
		}
	}
}
